'use strict';
function self() {
    return AnalyticsDealer;
}
var AnalyticsDealer = {
    ga: function () {
        if (window && window.ga) {
            var args = Array.prototype.slice.call(arguments);
            if (!arguments.length) {
                window.ga('send', 'pageview');
            } else {
                window.ga.apply(window.ga, args);
            }
        }
    },
    trackPageview: function (url, cb) {
        var payload = { 'page': url };
        if (cb !== null) {
            payload['hitCallback'] = cb;
        }
        self().ga('send', 'pageview', payload);
    },
    trackEvent(category, action, optLabel, optValue) {
        self().ga('send', 'event', category, action, optLabel, optValue);
    }
};
module.exports = AnalyticsDealer;
