'use strict';
var React = require('react');
var config = require('config');
function stylesheetPathForStylesheetName(name) {
    var release = config.idealist.release;
    return '/@/' + release + '/ido-1/css/' + name + '.css';
}
var HtmlHead = React.createClass({
    propTypes: { info: React.PropTypes.shape({ title: React.PropTypes.string }).isRequired },
    statics: {
        serverHtmlString: function (info) {
            return '<title>' + info.title + '</title>' + '<link rel="stylesheet" type="text/css" id="HtmlHeadStylesheet" href="' + stylesheetPathForStylesheetName(info.stylesheet) + '">';
        }
    },
    update: function (info) {
        document.title = info.title;
        var stylesheetTag = document.getElementById('HtmlHeadStylesheet');
        var currentStylesheet = stylesheetTag.getAttribute('href');
        if (currentStylesheet != stylesheetPathForStylesheetName(info.stylesheet)) {
            stylesheetTag.setAttribute('href', stylesheetPathForStylesheetName(info.stylesheet));
        }
    },
    componentDidMount: function () {
        this.update(this.props.info);
    },
    componentDidUpdate: function () {
        this.update(this.props.info);
    },
    render: function () {
        return null;
    }
});
module.exports = HtmlHead;
