var React = require('react');
var Auth = require('dealers/Auth');
var Wish = require('Wish');
var Worldly = require('Worldly');
var {I18N} = require('I18N');
var Link = require('elements/Link');
var Look = require('elements/Look');
var Spinner = require('elements/Spinner');
var ForgotPassword = React.createClass({
    mixins: [Worldly],
    getDefaultProps() {
        return {
            onRequestSent: () => {
            }
        };
    },
    render() {
        var email = this.props.email;
        var request = Auth.existingResetRequestForEmail(this.world(), email);
        var child = (
            <p style={{ marginBottom: 0 }}><a href="#" onClick={this.requestPasswordReset}><I18N
                        message={'Forgot your password?'}
                        context={this}
                        args={[]}
                        fallback={function () {
                            return <span>Forgot your password?</span>;
                        }} /></a></p>
        );
        if (request) {
            child = <Look wish={Auth.requestPasswordResetForEmail(this.world(), email)}>
                {{
                    Pending: () => <Spinner />,
                    Available: () => (
                        <p style={{ marginBottom: 0 }} className="pane-warning" role="alert">
                        <I18N
                                message={'A password reminder request was sent to {email}. Didn\'t get it? <Link>Contact us</Link>.'}
                                context={this}
                                args={[
                                    email,
                                    Link
                                ]}
                                fallback={function () {
                                    return <span>A password reminder request was sent to {email}. Didn't get it? <Link endpoint="contact-us">Contact us</Link>.</span>;
                                }} />
                    </p>
                    ),
                    Error: () => (
                        <span><I18N
                                message={'Something went wrong. Please <a:try href="#">try again</a:try>.'}
                                context={this}
                                args={[]}
                                fallback={function () {
                                    return <span>Something went wrong. Please <a href="#" onClick={this.requestPasswordReset}>try again</a>.</span>;
                                }} /></span>
                    )
                }}
            </Look>;
        }
        return (
            <div
                style={{
                    marginTop: -10,
                    minHeight: 60
                }}>{child}</div>
        );
    },
    requestPasswordReset(event) {
        Auth.requestPasswordResetForEmail(this.world(), this.props.email);
        this.props.onRequestSent();
        event.preventDefault();
    }
});
module.exports = ForgotPassword;
