'use strict';
var React = require('react/addons');
var _ = require('underscore');
var {I18N, i18n} = require('I18N');
var Signin = require('dealers/Signin');
var FormInput = require('elements/FormInput');
var LocationField = require('elements/LocationField');
var NameLocView = React.createClass({
    render: function () {
        return (
            <div>
            {!this.props.inline && (
                    <div>
                <h3><I18N
                                message={'Create your account'}
                                context={this}
                                args={[]}
                                fallback={function () {
                                    return <span>Create your account</span>;
                                }} /></h3>
                <p><I18N
                                message={'Looks like you\'re new here. Sign up!\n                Or, <a:login href="#">log in</a:login> with a different email.'}
                                context={this}
                                args={[]}
                                fallback={function () {
                                    return (
                                        <span>Looks like you're new here. Sign up!
                Or, <a onClick={this.props.goBack} href="#">log in</a> with a different email.</span>
                                    );
                                }} /></p>
            </div>
                )}
            <div className="field">
                <label><I18N
                            message={'Full Name'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span>Full Name</span>;
                            }} /></label>
                <FormInput type="text" ref="full_name" name="full_name"
                        value={this.props.fullName}
                        placeholder={i18n('Enter your full name')}
                        onChange={Signin.changeHandlerFor('full_name')}
                        onFocus={this.props.hideFieldValidation('full_name')}
                        validation={this.props.fullNameValidation} />
            </div>
            <div className="field">
                <label><I18N
                            message={'What should we call you?'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span>What should we call you?</span>;
                            }} /></label>
                <FormInput type="text" ref="first_name" name="first_name"
                        value={this.props.firstName}
                        placeholder={i18n('e.g. first name or nickname')}
                        onChange={Signin.changeHandlerFor('first_name')}
                        onFocus={this.props.hideFieldValidation('first_name')}
                        validation={this.props.firstNameValidation} />
            </div>
            <div className="field">
                <label><I18N
                            message={'Location'}
                            context={this}
                            args={[]}
                            fallback={function () {
                                return <span>Location</span>;
                            }} /></label>
                <LocationField
                        value={this.props.location}
                        autocompleteEndpointOptions={{ type: 'place' }}
                        onChange={this.props.changeLocation}
                        onKeyUp={this.props.keyAdvance}
                        onFocus={this.props.hideFieldValidation('location')}
                        validation={this.props.locationValidation} />
            </div>
        </div>
        );
    },
    isValid: () => true,
    componentDidMount: function () {
        this.refs.full_name.focus();
    }
});
module.exports = NameLocView;
