'use strict';
var React = require('react');
var Immutable = require('immutable');
var Spinner = require('elements/Spinner');
var publicKey = '6Le8mQITAAAAACDDrrCHL205La0P0-981nCwQ9kF';
var cleanUpCaptcha = function () {
    delete window.captchaLoaded;
    var container = document.getElementsByClassName('pls-container');
    if (container.length) {
        for (var r = 0; r < container.length; r++) {
            container[r].parentNode.removeChild(container[r]);
        }
    }
};
var Preloader = React.createClass({
    statics: { CAPTCHA_URL: 'http://www.google.com/recaptcha/api.js?' + 'onload=captchaLoaded&render=explicit' },
    componentDidMount() {
        window.captchaLoaded = () => {
            grecaptcha.render(this.refs.preload.getDOMNode(), {
                sitekey: publicKey,
                callback: () => {
                }
            });
        };
        var captchaBrain = document.createElement('SCRIPT');
        captchaBrain.setAttribute('src', Preloader.CAPTCHA_URL);
        document.head.appendChild(captchaBrain);
    },
    componentWillUnmount: cleanUpCaptcha,
    render() {
        return <div style={{ display: 'none' }} ref="preload" />;
    }
});
var NoCaptcha = React.createClass({
    propTypes: {
        onChange: React.PropTypes.func.isRequired,
        isMobile: React.PropTypes.bool
    },
    getDefaultProps() {
        return { isMobile: false };
    },
    componentWillMount() {
        window.captchaLoaded = this.renderCaptcha;
        this.setState({ waiting: !window.grecaptcha });
    },
    componentDidMount() {
        if (!this.state.waiting) {
            this.renderCaptcha();
        }
    },
    componentWillUnmount: cleanUpCaptcha,
    getInitialState() {
        return { waiting: true };
    },
    render() {
        var regularStyle = { minHeight: '7.7rem' };
        var mobileStyle = {
            webkitTransform: 'scale(0.85)',
            transform: 'scale(0.85)',
            webkitTransformOrigin: '0 0',
            transformOrigin: '0 0'
        };
        return (
            <div style={this.props.isMobile ? Object.assign({}, mobileStyle, regularStyle) : regularStyle} className="reCaptcha">
            <div ref="destination" />
            {this.state.waiting ? <Spinner /> : null}
        </div>
        );
    },
    shouldComponentUpdate() {
        return false;
    },
    renderCaptcha() {
        this.setState({ waiting: false });
        this.forceUpdate();
        grecaptcha.render(this.refs.destination.getDOMNode(), {
            sitekey: publicKey,
            callback: this.onResponseSuccess
        });
    },
    onResponseSuccess: function (resp) {
        this.props.onChange(Immutable.fromJS({ response: resp }));
    }
});
module.exports = {
    Preloader,
    NoCaptcha
};
