var React = require('react');
var classNames = require('classnames');
var ClippedNumber = require('elements/ClippedNumber');
var If = require('abc/if');
var Link = require('elements/Link');
var {I18N} = require('I18N');
var MenuAssets = React.createClass({
    render: function () {
        var assets = this.props.assets.toJS();
        var classes = { 'user-asset-navlinks': true };
        classes[this.props.className] = true;
        return (
            <If test={assets.length}>
          <dl className={classNames(classes)}>
            <dt className="asset-type-heading dropListItem">
               <span className="heading-label">{this.props.title}</span>
               <If test={assets.length > 3}>
                 <Link endpoint={this.props.seeAllEndpoint} className="more-than-three"><I18N
                                    message={'See all'}
                                    context={this}
                                    args={[]}
                                    fallback={function () {
                                        return <span>See all</span>;
                                    }} /></Link>
               </If>
            </dt>
            <dd className="dropListItem">
              <dl className="asset-links-body">
                {assets.map(asset => (
                                <dd className="dropListItem" key={asset.url}>
                    <a href={asset.url} className={asset.status == 'Active' ? '' : 'inactive'}>
                      {asset.name}
                      <If test={asset.notification_count}>
                        &nbsp;(<ClippedNumber value={asset.notification_count} />)
                      </If>
                      <If test={asset.status != 'Active'}>
                        &nbsp;[<span className="asset-status">{asset.status}</span>]
                      </If>
                    </a>
                </dd>
                            ))}
              </dl>
            </dd>
          </dl>
        </If>
        );
    }
});
var AdministeredAssets = React.createClass({
    render() {
        var assets = this.props.assets;
        return (
            <div>
            <MenuAssets className="my-orgs" title="Organizations"
                    assets={assets.get('orgs')}
                    seeAllEndpoint="me/dashboard/connections" />
            <MenuAssets className="my-connector-teams" title="Connector Teams"
                    assets={assets.get('connector_teams')}
                    seeAllEndpoint="me/dashboard/groups" />
            <MenuAssets className="my-action-groups" title="Action Groups"
                    assets={assets.get('idealist_groups')}
                    seeAllEndpoint="me/dashboard/groups" />
        </div>
        );
    }
});
module.exports = AdministeredAssets;
